//Source file for Game loading.

#include <header.h>
#include <ascii.h>
#include <ascrender.h>
#include <global.h>
#include <gameglobal.h>
#include <gameload.h>
#include <game.h>
#include <log.h>

//Unload Train Sprites
void unload_train_sprites(){
	if(aacoach) unload_asciiart(aacoach);
	aacoach=NULL;

	if(aacoach3) unload_asciiart(aacoach3);
	aacoach3=NULL;

	if(aacoach2) unload_asciiart(aacoach2);
	aacoach2=NULL;

	if(aaconnector) unload_asciiart(aaconnector);
	aaconnector=NULL;

	if(aaengine) unload_asciiart(aaengine);
	aaengine=NULL;

	if(aasmoke) unload_asciiart(aasmoke);
	aasmoke=NULL;

	if(aatrack) unload_asciiart(aatrack);
	aatrack=NULL;
}

//Load Train Sprites
int load_train_sprites(){
	char aafilename[MAXSTR],filename[MAXSTR],typename[MAXSTR];
	FILE *fascii=NULL;

	strcpy(typename,"Train");

	strcpy(filename,"coach.txt");
	*aafilename=0;				
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aacoach=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aacoach) return -1;

	strcpy(filename,"coach2.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aacoach2=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aacoach2) return -1;

	strcpy(filename,"coach3.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aacoach3=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aacoach3) return -1;

	strcpy(filename,"connector.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aaconnector=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aaconnector) return -1;

	strcpy(filename,"engine.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aaengine=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aaengine) return -1;

	aasmoke=create_asciiart(3,3);
	if(!aasmoke) return -1;

	aasmoke->a=255; asciiart_clear(aasmoke);

	strcpy(filename,"track.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aatrack=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aatrack) return -1;

	return 0;
}

//Unload Player Sprites
void unload_player_sprites(){
	if(aaplayer) unload_asciiart(aaplayer);
	aaplayer=NULL;

	if(aaplayerj) unload_asciiart(aaplayerj);
	aaplayerj=NULL;

	if(aaplayerc) unload_asciiart(aaplayerc);
	aaplayerc=NULL;
}

//Load Player Sprites
int load_player_sprites(){
	char aafilename[MAXSTR],filename[MAXSTR],typename[MAXSTR];
	FILE *fascii=NULL;

	strcpy(typename,"Player");

	strcpy(filename,"player.txt");
	*aafilename=0;				
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aaplayer=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aaplayer) return -1;

	strcpy(filename,"playerj.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aaplayerj=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aaplayerj) return -1;

	strcpy(filename,"playerc.txt");
	*aafilename=0;
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aaplayerc=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aaplayerc) return -1;

	return 0;
}

//Unload Numbers Sprites
void unload_numbers_sprites(){
	if(aanumbers) unload_asciiart(aanumbers);
	aanumbers=NULL;
}


//Load Numbers Sprites
int load_numbers_sprites(){
	char aafilename[MAXSTR],filename[MAXSTR],typename[MAXSTR];
	FILE *fascii=NULL;

	strcpy(typename,"Numbers");

	strcpy(filename,"numbers.txt");
	*aafilename=0;				
	sprintf(aafilename,"%s%c%s%c%s%c%s","Data",PATHSEP,"Sprites",PATHSEP,typename,PATHSEP,filename);
	fascii=fopen(aafilename,"r"); 
	if(fascii) {	
		//Loading ASCIIMap
		#ifdef VERBOSE
			log_printf("Loading ASCIIMap from %s",aafilename);
		#endif //VERBOSE
		aanumbers=load_asciiart_file(fascii); fclose(fascii); fascii=NULL;
	}
	if(!aanumbers) return -1;
	
	return 0;
}

//Unload Game Sprites
void unload_game_sprites(){
	unload_numbers_sprites();
	unload_train_sprites();
	unload_player_sprites();

	log_printf("Unloaded Game Sprites");
}

//Load Game Sprites
int load_game_sprites(){
	int status=-1;

	if(status=load_train_sprites()) return status;
	if(status=load_player_sprites()) return status;
	if(status=load_numbers_sprites()) return status;

	log_printf("Loaded Game Sprites");
	return 0;
}

//Unload Game Sounds
void unload_game_sounds(){
	if(trainmusic) destroy_midi(trainmusic);
	trainmusic=NULL;
}

//Load Game Sounds
int load_game_sounds(){
	char midifilename[MAXSTR],filename[MAXSTR];

	if(!soundsystem) return 0;

	//Loading MIDI
	strcpy(filename,"train.mid");
	*midifilename=0;
	sprintf(midifilename,"%s%c%s%c%s","Data",PATHSEP,"Music",PATHSEP,filename);
	trainmusic=load_midi(midifilename);

	if(trainmusic)
	#ifdef VERBOSE
		log_printf("Loaded MIDI from %s",midifilename);
	#else
		;
	#endif //VERBOSE
	else
		return -1;

	return 0;
}