//Source file for level rendering.

#include <header.h>
#include <global.h>
#include <gameglobal.h>
#include <level.h>
#include <levrender.h>
#include <ascii.h>
#include <ascrender.h>
#include <log.h>


//Uninitialize Level Renderer
void quit_level_renderer(){
	log_printf("Quitting Level Renderer");
}

//Initialize Level Renderer
int init_level_renderer(){
	log_printf("Initializing Level Renderer");

	return 0;
}

//Render ASCII Map
void render_asciimap(BITMAP *bitmap, aamap *givaam, attrmap *givam, int camx, int camy, int depth, int flags){
	int camax,camay;
        int endbx,endby;
	int startx,starty,endx,endy;
	int ascbwidth,ascbheight;

	//ASCII Bitmap Width, Height
	ascbwidth=givaam->width*xmul;
	ascbheight=givaam->height*ymul; 

	//Normalize Camera to ASCII Map	
	camax=(ascbwidth*camx)/(givam->width*givam->tilewidth); camay=(ascbheight*camy)/(givam->height*givam->tileheight);
        camax+=depth; camay+=depth;
	
	//Center Drawing Area
	endbx=camax+(bitmap->w/2); endby=camay+(bitmap->h/2);
	if(endbx> ascbwidth) endbx=ascbwidth; if(endby>ascbheight) endby=ascbheight;	
	startx=endbx-bitmap->w; starty=endby-bitmap->h;
	if(startx<0) startx=0;	if(starty<0) starty=0;
	
	//To Clipped Mode: ASCII
	endx=(startx+bitmap->w)/xmul;
	endy=(starty+bitmap->h)/ymul;

	startx/=xmul; //Assume
	starty/=ymul; 

	asciiart_bitmap_blit(givaam, bitmap, startx, starty, endx, endy, 0, 0);
}

//Render Level
void render_level(BITMAP *bitmap, level *givlevel, int camx, int camy, int flags){
	int i;
	int depth=0;

	attrmap *lam;

	lam=givlevel->am;

        clear_to_color(bitmap,makecol(lam->r,lam->g,lam->b));

	for(i=0;i<givlevel->nlayers;++i) {
		//Render ASCII
		if(givlevel->layertypes[i]==LEVEL_AARTMAP) {	
			render_asciimap(bitmap, givlevel->layers[i], lam, camx, camy, depth++, flags);
		}
	}
	if(flags){
		textprintf_ex(bitmap,font,0,0,makecol(255,255,255),-1,"Camera: %5d,%5d",camx,camy);
	}
}
